                          /***  HOLA ! ***/

  /* Esta es la documentacin de los programas CL386.EXE y MK386.EXE */


char *Indice[] =
{
   "Introduccin.",
   "Cmo funcionan CL386 y MK386?",
        "Qu programas necesitan CL386 y MK386?",
        "Algoritmo de CL386 y MK386",
        "Diferencias entre CL386 y MK386.",
   "Opciones of CL386 y MK386.",
   "Cdigos de error.",
   "Comentarios.",
   "Apndices.",
        "Pistas para usar TASM v4.1 para DOS!",
        "Las garantas.",
        "Copyright.",
        "Direccin de contacto."
};

/*
**  I.  Introduccin.
*/

    CL386 y MK386 son shells para compilar, ensamblar y enlazar con el
compilador de C CC386.EXE. Escrito especialmente para el compilador de David
Lindauer!

   Lo he compilado con los siguientes compiladores de C/C++:
       Borland C/C++ v3.1
       Watcom C/C++ v10.6
       Watcom 386 C/C++ v10.6
   CL386 es anlogo a:
       BCC.EXE (Borland C/C++)
       WCL.EXE (Watcom C/C++)
       CL.EXE  (MS C/C++)
   MK386 es anlogo a:
       MAKER  (crea el MAKEFILE para los compiladores de C/C++)
       GENMKF (genera el MAKEFILE para Watcom C/C++)


/*
**  II.  Cmo funcionan el CL386 y el MK386?
*/


//  II.1  Qu se necesita para el CL386?

    Para el CL386 y el MK386 son necesarios los siguientes ficheros:

        CC386.EXE -  necesario !!!
        TASM.EXE, NASM.EXE o MASM.EXE ( MASM no funciona actualmente )
        TLINK.EXE, WLINK.EXE, VALX.EXE o LINK.EXE

    Para el MK386 tambin necesitas:

        MAKE (Borland), WMAKE (Watcom), IMAKE.

    Comprobar (o aadir) el path a estos programas en la variable de entorno!


//  II.2  Algoritmo del CL386 y MK386

    1) Recogida de parmetros.  Los parmetros son <fichero> u <opcin>.

        Parmetros que puedes usar:

            - fichero de configuracin CL386.CFG (el MK386 usa MK386.CFG). Si
        renombras CL386.EXE a XXX.EXE, el nombre del fichero de configuracin
        ha de ser XXX.CFG. Se busca el CL386.CFG en el directorio actual, y si
        no se encuentra se busca en el directorio en el que est CL386.EXE.
            - variable de entorno CL386 (MK386 usa MK386). Ejemplo:
        SET CL386=-A -$L#WLINK
            - en la lnea de comandos. Los ficheros admiten comodines '?' y '*'

    2) Para compilar, ensamblar y enlazar, CL386 genera el fichero TEMP.$$$ en
    el directorio actual. CC386 se usa siempre como compilador, el ensamblador y
    el enlazador estn especificados en el fichero .CFG o en la lnea de
    comandos. MK386 crea un fichero 'make' y entonces ejecutar el programa Make.

    3) Si se encuentra la opcin /? (/h o /H) o no hay fichero en los
    parmetros - se muestra el mensaje de ayuda.


//  II.3  Diferencias entre CL386 y MK386.

    CL386 y MK386 usan un fuente, pero generan una salida diferente :)
    Diferencias:
        - CL386 SIEMPRE compila todos los ficheros, MK386 - slo los que hayan
          cambiado;
        - MK386 genera el MAKEFILE y ejecuta MAKE.EXE;
        - MK386 usa menos memoria;
        - MK386 NO compila ni ensambla -  SOLO CONTRUYE !!!;

/*
**  III. Opciones de CL386 y MK386.
*/

    Uso: CL386.EXE [opciones] ficheros
        o
    Uso: MK386.EXE [opciones] ficheros

    Las opciones son:

        @fname    especifica fichero de respuesta, fichero con opciones y
                  ficheros
        /A[+|-]   deshabilita extensiones, para ms informacin ver CC386.DOC
        /?,/h,/H  este mensaje de ayuda
        /Dxxx     define algo, por ejemplo /DDOS32=1
        /Ennn     mximo nmero de errores, ver ms informacin en CC386.DOC
        /Ipath    especifica el path de los ficheros include, cuando se buscan
                  ficheros include
        /Lpath    specifica el directorio de .LIB y .OBJ, cuando se buscan los
                  ficheros .OBJ y .LIB
        /Oxxx     optimiza los parmetros para el CC386, ms informacin en
                  CC386.DOC
        /Cxxx     parmetros de la generacin de cdigo para CC386, ms
                  informacin en CC386.DOC
        /K[-|+]   conserva el fichero de respuesta, TEMP.$$$ para el CC386
        /k[-|+]   conserva los ficheros generados, ficheros .ASM y .OBJ
        /e[+|-]   escribe los errores a un fichero, ms informacin en
                  CC386.DOC
        /m[-|+]   genera el fichero .MAP
        /l[-|+]   escribe el fichero de lista, ms informacin en CC386.DOC
        /i[-|+]   escribe el fichero preprocesado, ms informacin en
                  CC386.DOC
        /w-xxx    deshabilita el warning, ms informacin en CC386.DOC
        /n[-|+]   no hay fichero .LIB y .OBJ por defecto, no enlaza STARTUP ni
                  CLDOS.LIB
        /e=name   indica el nombre del fichero .EXE
        /v[-|+]   informacin de depuracin, para el PMODE usa la versin
                  startup del DEBUG
        /c        compila, ejecuta SOLO CC386 (no funciona en MK386)
        /a        ensambla, ejecuta SOLO CC386 y ensamblador (no funciona en el
                  MK386)
        /B[-|+]   construye todo (no funciona en CL386)
        /M[+|-]   ejecuta MAKE.EXE (no funciona en CL386)
        /$C=name  compilador de C alternativo, name es SOLO 'CC386'
        /$A=name  ensamblador alternativo, name es 'TASM', 'MASM', 'NASM'
        /$L=name  enlazador alternativo, name es 'TLINK', 'WLINK', 'LINK',
                  'VALX'
        /$M=name  Maker alternativo, name es 'MAKE', 'WMAKE', 'IMAKE' (MK386)
        /$D=name  extensor de DOS alternativo, name es 'PMODE', 'PMODEW',
                  'DOS4G', 'WDOSX'


/*
** IV.  Cdigos de error.
*/

    El programa devuelve los siguientes cdigos de salida:

          == 0  - Ok
          != 0  - Error!

    Tambin devuelve los cdigos de error del CC386, etc!


/*
**  V.  Comentarios.
*/

    - no uses ficheros de respuesta incluidos!. Por ejemplo:
        fichero1: @fichero2  fichero2: @fichero1  ;
    - usa la opcin /K para ver el fichero de respuesta TEMP.$$$ ;
    - usa la opcin /k para ver los ficheros .ASM y .OBJ;
    - usa la opcin /a para SOLO ensamblar y /c para SOLO compilar;
    - usa la opcin /v para hacer la versin de depuracin del programa (SOLO
      con PMODE);
    - en las opciones -$C=name, -$A=name, -$L=name, -$D=name y -$M=name puedes
      usar -$C#name, -$A#name, -$L#name, -$D#name y -$M#name ;
    - cambia el extensor de DOS con la opcin -$D=name. DOS/4G[W], PMODE/W,
      WDOSX se usan SOLO con WLINK, PMODE con lo dems...;
    - no aadas la opcin /? (/h, /H) en CL386.CFG (MK386), o la variable de
      entorno CL386 (MK386);
    - los ficheros .OBJ y .ASM generados se ponen en el directorio actual,
      MK386 NO borra los ficheros .OBJ y borra los fichero .ASM, CL386 borra
      todos los fichero .ASM y .OBJ generados;
    - si quieres ver el fichero de respuesta para compilar (ensamblar) usa -c
      -k (-a -k);
    - para ver el nombre del fichero de lista de CC386 y TASM, usa la opcin
      -a o -c ;
    - si quieres ver el fichero del lista para compilar (ensamblar), usa -c
      -l (-a -l);
    - CL386 usa aproximadamente 50 Kb de memoria, para menos memoria usa
      MK386.EXE
    - puedes aadir el path hasta las libreras, /Lpath1;path2; , PERO solo el
      primer path (path1) es usado para buscar CLDOS.LIB y C0DOS.OBJ !


/*
**  VI.  Apndices.
*/

//  VI.1  Pistas para usar TASM v4.1 para DOS.

     No uses TASM v4.1 !!! Por ejemplo compila con TASM v4.1 :

============================================= 1.ASM
        .model tiny
        .code
        .386
  start:
        rept 1024
        local hi
        jc hi
  hi:
        endm
        end start
=============================================
============================================= MAKE.BAT
@tasm /m2 1.ASM
@tlink /3/c/t 1.OBJ
=============================================

       y desensambla el cdigo en 1.COM :((((((((((((

    Esto da error en TASM y TASMX (DPMI 16-bits)

    Tambin, con la directiva .386p en TASM v4.x y posteriores no hace
correctamente la llamada con punteros FAR :

============================================= 2.ASM
        .386p
        .code

        call foo C, es edi
============================================

    Ahora uso TASM32 v5.0 con el parche de http://www.borland.com


//  VI.2  Las grarantas.

     CL386 y MK386 son FREEWARE con los fuentes!
      T usas estos programas bajo tu propio riesgo !!!


//  VI.3  Copyright.

    (c) CL386 y MK386   Kirill Joss
    (c) CC386           David Lindauer (camille@bluegrass.net)
    (c) PMODE           Tran


//  VI.4  Direccin de contacto.

    Tus notas, avisos, cervezas, etc. envalas a las direcciones:

    E-Mail:    jk@zi3.cyb.univ.kiev.ua

    FidoNet:   2:463/218.12 AKA 2:463/59.29


                                                       Kirill Joss

=============================================================================
---
   E-Mail jk@zi3.cyb.univ.kiev.ua         FidoNet 2:463/59.29, 2:463/218.12
                                                 2:463/231.12, 2:463/140.12
   Kirill Joss.